// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/id/perform.c $
// $Rev: 53246 $
// $Date: 2023-06-22 15:52:38 -0500 (Thu, 22 Jun 2023) $

// 16AIO: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _input_modes(void)
{
	gsc_label("Input Modes");
	printf("Differential, Single-Ended, Zero Test, +Vref Test, Chan 0/1/2/3 Loopback\n");
	return(0);
}



//*****************************************************************************
static int _voltage_ranges(void)
{
	gsc_label("Voltage Ranges");
	printf("+-10V, +-5V, +-2.5V\n");
	return(0);
}



//*****************************************************************************
static int _rate_generators(void)
{
	gsc_label("Rate Generators");
	printf("2  (A-B)\n");
	return(0);
}



//*****************************************************************************
static int _clocking_sources(void)
{
	gsc_label("Clocking Sources");
	printf("Rate Generator(s), External, Software\n");
	return(0);
}



//*****************************************************************************
static int _sampling_modes(void)
{
	gsc_label("Input Modes");
	printf("Continuous, Burst\n");

	gsc_label("Output Modes");
	printf("Immediate, Synchronous, Burst, Looping\n");
	return(0);
}



//*****************************************************************************
static int _digital_io(void)
{
	gsc_label("Digital I/O");
	printf("16 Bi-Directional Signals  (2 ports, 8-bits each)\n");
	return(0);
}



//*****************************************************************************
static int _id_device_reg(const args_t* args)
{
	int						errs;
	gsc_reg_def_t			list[2]	= { { NULL }, { NULL } };
	const gsc_reg_def_t*	ptr;

	printf("\n");
	ptr	= (gsc_reg_def_t*) aio_reg_get_def_id(AIO_GSC_FRR);

	if (ptr)
	{
		list[0]	= ptr[0];
		errs	= gsc_reg_list(args->fd, list, 1, aio_reg_read);
	}
	else
	{
		errs	= 1;
		printf(	"FAIL <---  (%d. aio_reg_get_def_id, AIO_GSC_FRR)\n",
				__LINE__);
	}

	return(errs);
}



//*****************************************************************************
static int _register_map(const args_t* args)
{
	int	errs;

	printf("\n");
	errs	= aio_reg_list(args->fd, args->detail);
	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;
	int	i;

	gsc_label("Device Features");
	printf("\n");

	gsc_label_level_inc();

	errs	+= _input_modes();
	errs	+= _voltage_ranges();
	errs	+= _rate_generators();
	errs	+= _clocking_sources();
	errs	+= _sampling_modes();
	errs	+= _digital_io();

	for (i = 0; i < AIO_IOCTL_QUERY_LAST; i++)
		errs	+= aio_query(args->fd, -1, 1, i, NULL);

	gsc_label_level_dec();

	errs	+= _id_device_reg(args);
	errs	+= _register_map(args);
	printf("\n");

	return(errs);
}


