// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/sbtest/ai_mode.c $
// $Rev: 53254 $
// $Date: 2023-06-22 15:56:25 -0500 (Thu, 22 Jun 2023) $

// 16AIO: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_MODE,
			/* arg		*/	AIO_AI_MODE_DIFF,
			/* reg		*/	AIO_GSC_BCR,
			/* mask		*/	0x7,
			/* value	*/	0x0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_MODE,
			/* arg		*/	AIO_AI_MODE_SINGLE,
			/* reg		*/	AIO_GSC_BCR,
			/* mask		*/	0x7,
			/* value	*/	0x1
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_MODE,
			/* arg		*/	AIO_AI_MODE_ZERO,
			/* reg		*/	AIO_GSC_BCR,
			/* mask		*/	0x7,
			/* value	*/	0x2
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_MODE,
			/* arg		*/	AIO_AI_MODE_VREF,
			/* reg		*/	AIO_GSC_BCR,
			/* mask		*/	0x7,
			/* value	*/	0x3
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_MODE,
			/* arg		*/	AIO_AI_MODE_AO_0,
			/* reg		*/	AIO_GSC_BCR,
			/* mask		*/	0x7,
			/* value	*/	0x4
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_MODE,
			/* arg		*/	AIO_AI_MODE_AO_1,
			/* reg		*/	AIO_GSC_BCR,
			/* mask		*/	0x7,
			/* value	*/	0x5
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_MODE,
			/* arg		*/	AIO_AI_MODE_AO_2,
			/* reg		*/	AIO_GSC_BCR,
			/* mask		*/	0x7,
			/* value	*/	0x6
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AI_MODE,
			/* arg		*/	AIO_AI_MODE_AO_3,
			/* reg		*/	AIO_GSC_BCR,
			/* mask		*/	0x7,
			/* value	*/	0x7
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= aio_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, __LINE__, list);
	errs	+= service_ioctl_reg_get_list(fd, __LINE__, list);

	errs	+= service_ioctl_set_reg_list(fd, __LINE__, list);
	errs	+= service_ioctl_reg_get_list(fd, __LINE__, list);

	errs	+= aio_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	return(0);
}



/******************************************************************************
*
*	Function:	ai_mode_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AIO_IOCTL_AI_MODE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai_mode_test(int fd)
{
	int	errs	= 0;

	gsc_label("AIO_IOCTL_AI_MODE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


