// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/sbtest/ao_buf_thr_lvl.c $
// $Rev: 53254 $
// $Date: 2023-06-22 15:56:25 -0500 (Thu, 22 Jun 2023) $

// 16AIO: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_BUF_THR_LVL,
			/* arg		*/	0x0000,
			/* reg		*/	AIO_GSC_OBCR,
			/* mask		*/	0x7FFF,
			/* value	*/	0x0000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_BUF_THR_LVL,
			/* arg		*/	0x0001,
			/* reg		*/	AIO_GSC_OBCR,
			/* mask		*/	0x7FFF,
			/* value	*/	0x0001
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_BUF_THR_LVL,
			/* arg		*/	0x0002,
			/* reg		*/	AIO_GSC_OBCR,
			/* mask		*/	0x7FFF,
			/* value	*/	0x0002
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_BUF_THR_LVL,
			/* arg		*/	0x0004,
			/* reg		*/	AIO_GSC_OBCR,
			/* mask		*/	0x7FFF,
			/* value	*/	0x0004
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_BUF_THR_LVL,
			/* arg		*/	0x0008,
			/* reg		*/	AIO_GSC_OBCR,
			/* mask		*/	0x7FFF,
			/* value	*/	0x0008
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_BUF_THR_LVL,
			/* arg		*/	0x0010,
			/* reg		*/	AIO_GSC_OBCR,
			/* mask		*/	0x7FFF,
			/* value	*/	0x0010
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_BUF_THR_LVL,
			/* arg		*/	0x0020,
			/* reg		*/	AIO_GSC_OBCR,
			/* mask		*/	0x7FFF,
			/* value	*/	0x0020
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_BUF_THR_LVL,
			/* arg		*/	0x0040,
			/* reg		*/	AIO_GSC_OBCR,
			/* mask		*/	0x7FFF,
			/* value	*/	0x0040
		},

		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_BUF_THR_LVL,
			/* arg		*/	0x0080,
			/* reg		*/	AIO_GSC_OBCR,
			/* mask		*/	0x7FFF,
			/* value	*/	0x0080
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_BUF_THR_LVL,
			/* arg		*/	0x0100,
			/* reg		*/	AIO_GSC_OBCR,
			/* mask		*/	0x7FFF,
			/* value	*/	0x0100
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_BUF_THR_LVL,
			/* arg		*/	0x0200,
			/* reg		*/	AIO_GSC_OBCR,
			/* mask		*/	0x7FFF,
			/* value	*/	0x0200
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_BUF_THR_LVL,
			/* arg		*/	0x0400,
			/* reg		*/	AIO_GSC_OBCR,
			/* mask		*/	0x7FFF,
			/* value	*/	0x0400
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_BUF_THR_LVL,
			/* arg		*/	0x0800,
			/* reg		*/	AIO_GSC_OBCR,
			/* mask		*/	0x7FFF,
			/* value	*/	0x0800
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_BUF_THR_LVL,
			/* arg		*/	0x1000,
			/* reg		*/	AIO_GSC_OBCR,
			/* mask		*/	0x7FFF,
			/* value	*/	0x1000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_BUF_THR_LVL,
			/* arg		*/	0x2000,
			/* reg		*/	AIO_GSC_OBCR,
			/* mask		*/	0x7FFF,
			/* value	*/	0x2000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_BUF_THR_LVL,
			/* arg		*/	0x4000,
			/* reg		*/	AIO_GSC_OBCR,
			/* mask		*/	0x7FFF,
			/* value	*/	0x4000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_BUF_THR_LVL,
			/* arg		*/	0x0000,
			/* reg		*/	AIO_GSC_OBCR,
			/* mask		*/	0x7FFF,
			/* value	*/	0x0000
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= aio_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, __LINE__, list);
	errs	+= service_ioctl_reg_get_list(fd, __LINE__, list);

	errs	+= service_ioctl_set_reg_list(fd, __LINE__, list);
	errs	+= service_ioctl_reg_get_list(fd, __LINE__, list);

	errs	+= aio_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	static const service_data_t	list_1[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_CLK_SRC,
			/* arg		*/	AIO_AO_CLK_SRC_DISABLE,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_BUF_CLEAR,
			/* arg		*/	0,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_REG_WRITE,
			/* cmd		*/	0,
			/* arg		*/	254,
			/* reg		*/	AIO_GSC_ODBR,
			/* mask		*/	0,
			/* value	*/	0
		},
		{				// wait for propogation
			/* service	*/	SERVICE_SLEEP,
			/* cmd		*/	0,
			/* arg		*/	1,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},

		{ SERVICE_END_LIST }
	};

	static service_data_t	list_2[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AO_BUF_THR_LVL,
			/* arg		*/	-1,			// Set below
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{				// wait for propogation
			/* service	*/	SERVICE_SLEEP,
			/* cmd		*/	0,
			/* arg		*/	1,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_REG_TEST,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AIO_GSC_OBCR,
			/* mask		*/	0x10000,
			/* value	*/	0x00000
		},
		{
			/* service	*/	SERVICE_REG_WRITE,
			/* cmd		*/	0,
			/* arg		*/	1,
			/* reg		*/	AIO_GSC_ODBR,
			/* mask		*/	0,
			/* value	*/	0
		},
		{				// wait for propogation
			/* service	*/	SERVICE_SLEEP,
			/* cmd		*/	0,
			/* arg		*/	1,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_REG_TEST,
			/* cmd		*/	0,
			/* arg		*/	0,
			/* reg		*/	AIO_GSC_OBCR,
			/* mask		*/	0x10000,
			/* value	*/	0x10000
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	int	i;

	errs	+= aio_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, __LINE__, list_1);

	for (i = 0; i < 5; i++)
	{
		list_2[0].arg	= i;
		errs			+= service_ioctl_set_reg_list(fd, __LINE__, list_2);
	}

	errs	+= aio_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	ao_buf_thr_lvl_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AIO_IOCTL_AO_BUF_THR_LVL.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ao_buf_thr_lvl_test(int fd)
{
	int	errs	= 0;

	gsc_label("AIO_IOCTL_AO_BUF_THR_LVL");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


