// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/sbtest/autocal_status.c $
// $Rev: 53254 $
// $Date: 2023-06-22 15:56:25 -0500 (Thu, 22 Jun 2023) $

// 16AIO: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	// There are no persistant bits to test.
	return(0);
}



//*****************************************************************************
static int _function_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AUTOCAL,
			/* arg		*/	0,
			/* reg		*/	AIO_GSC_BCR,
			/* mask		*/	0x4000,
			/* value	*/	0x4000
		},

		{ SERVICE_END_LIST }
	};

	int	errs	= 0;
	int	ret;
	s32	sts;

	errs	+= aio_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, __LINE__, list);
	ret		= aio_ioctl(fd, AIO_IOCTL_AUTOCAL_STATUS, &sts);
	errs	+= ret ? 1 : 0;

	if (sts != AIO_AUTOCAL_STATUS_PASS)
	{
		errs++;
		printf("FAIL <---  (Autocalibration did not pass)\n");
	}

	errs	+= service_ioctl_set_reg_list(fd, __LINE__, list);
	ret		= aio_ioctl(fd, AIO_IOCTL_AUTOCAL_STATUS, &sts);
	errs	+= ret ? 1 : 0;

	if (sts != AIO_AUTOCAL_STATUS_PASS)
	{
		errs++;
		printf("FAIL <---  (Autocalibration did not pass)\n");
	}

	errs	+= aio_initialize(fd, -1, 0);
	return(errs);
}



/******************************************************************************
*
*	Function:	autocal_status_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AIO_IOCTL_AUTOCAL_STATUS.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int autocal_status_test(int fd)
{
	int	errs	= 0;

	gsc_label("AIO_IOCTL_AUTOCAL_STATUS");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


