// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/sbtest/aux_write.c $
// $Rev: 53254 $
// $Date: 2023-06-22 15:56:25 -0500 (Thu, 22 Jun 2023) $

// 16AIO: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AUX_WRITE,
			/* arg		*/	0,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0x20000,
			/* value	*/	0x00000
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_AUX_WRITE,
			/* arg		*/	1,
			/* reg		*/	AIO_GSC_DIOPR,
			/* mask		*/	0x20000,
			/* value	*/	0x20000
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= aio_initialize(fd, -1, 0);

	errs	+= service_ioctl_set_reg_list(fd, __LINE__, list);

	// We can't run the service_ioctl_reg_get_list() tests because the output
	// value is cached by the driver. This is done to handle the firmware,
	// which uses a single register implementation rather than two registers.

	errs	+= service_ioctl_set_reg_list(fd, __LINE__, list);

	errs	+= aio_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// This requires additional equipment.
	return(0);
}



/******************************************************************************
*
*	Function:	aux_write_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AIO_IOCTL_AUX_WRITE.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int aux_write_test(int fd)
{
	int	errs	= 0;

	gsc_label("AIO_IOCTL_AUX_WRITE");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


