// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/sbtest/irq0_sel.c $
// $Rev: 53254 $
// $Date: 2023-06-22 15:56:25 -0500 (Thu, 22 Jun 2023) $

// 16AIO: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _service_test(int fd)
{
	static const service_data_t	list[]	=
	{
		{
			/* service	*/	SERVICE_SLEEP_MS,
			/* cmd		*/	0,
			/* arg		*/	50,
			/* reg		*/	0,
			/* mask		*/	0,
			/* value	*/	0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_IRQ0_SEL,
			/* arg		*/	AIO_IRQ0_IDLE_INIT,
			/* reg		*/	AIO_GSC_ICR,
			/* mask		*/	0x7,
			/* value	*/	0x0
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_IRQ0_SEL,
			/* arg		*/	AIO_IRQ0_AUTOCAL_DONE,
			/* reg		*/	AIO_GSC_ICR,
			/* mask		*/	0x7,
			/* value	*/	0x1
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_IRQ0_SEL,
			/* arg		*/	AIO_IRQ0_AUX_IN_L2H,
			/* reg		*/	AIO_GSC_ICR,
			/* mask		*/	0x7,
			/* value	*/	0x2
		},
		{
			/* service	*/	SERVICE_NORMAL,
			/* cmd		*/	AIO_IOCTL_IRQ0_SEL,
			/* arg		*/	AIO_IRQ0_AUX_IN_H2L,
			/* reg		*/	AIO_GSC_ICR,
			/* mask		*/	0x7,
			/* value	*/	0x3
		},

		{ SERVICE_END_LIST }
	};

	int errs	= 0;

	errs	+= aio_initialize(fd, -1, 0);
	errs	+= service_ioctl_set_reg_list(fd, __LINE__, list);
	errs	+= service_ioctl_set_reg_list(fd, __LINE__, list);
	errs	+= aio_initialize(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _function_test(int fd)
{
	// Interrupts are tested under the Wait Event test.
	return(0);
}



/******************************************************************************
*
*	Function:	irq0_sel_test
*
*	Purpose:
*
*		Perform a test of the IOCTL service AIO_IOCTL_IRQ0_SEL.
*
*	Arguments:
*
*		fd		The handle for the device to access.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int irq0_sel_test(int fd)
{
	int	errs	= 0;

	gsc_label("AIO_IOCTL_IRQ0_SEL");
	errs	+= _service_test(fd);
	errs	+= _function_test(fd);

	if (errs == 0)
		printf("PASS\n");

	return(errs);
}


