// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/samples/sbtest/perform.c $
// $Rev: 53254 $
// $Date: 2023-06-22 15:56:25 -0500 (Thu, 22 Jun 2023) $

// 16AIO: Sample Application: source file

#include "main.h"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	int	errs	= 0;

	errs	+= reg_read_test(args->fd);			// AIO_IOCTL_REG_READ
	errs	+= reg_write_test(args->fd);		// AIO_IOCTL_REG_WRITE
	errs	+= reg_mod_test(args->fd);			// AIO_IOCTL_REG_MOD
	errs	+= query_test(args->fd);			// AIO_IOCTL_QUERY
	errs	+= initialize_test(args->fd);		// AIO_IOCTL_INITIALIZE
	errs	+= autocal_test(args->fd);			// AIO_IOCTL_AUTOCAL
	errs	+= autocal_status_test(args->fd);	// AIO_IOCTL_AUTOCAL_STATUS

	errs	+= ai_buf_clear_test(args->fd);		// AIO_IOCTL_AI_BUF_CLEAR
	errs	+= ai_buf_thr_lvl_test(args->fd);	// AIO_IOCTL_AI_BUF_THR_LVL
	errs	+= ai_buf_thr_sts_test(args->fd);	// AIO_IOCTL_AI_BUF_THR_STS
	errs	+= ai_mode_test(args->fd);			// AIO_IOCTL_AI_MODE
	errs	+= ai_scan_1_chan_test(args->fd);	// AIO_IOCTL_AI_SCAN_1_CHAN
	errs	+= ai_scan_clk_src_test(args->fd);	// AIO_IOCTL_AI_SCAN_CLK_SRC
	errs	+= ai_scan_size_test(args->fd);		// AIO_IOCTL_AI_SCAN_SIZE
	errs	+= ai_sync_test(args->fd);			// AIO_IOCTL_AI_SYNC

	errs	+= ao_buf_clear_test(args->fd);		// AIO_IOCTL_AO_BUF_CLEAR
	errs	+= ao_buf_thr_lvl_test(args->fd);	// AIO_IOCTL_AO_BUF_THR_LVL
	errs	+= ao_buf_thr_sts_test(args->fd);	// AIO_IOCTL_AO_BUF_THR_STS
	errs	+= ao_burst_clk_src_test(args->fd);	// AIO_IOCTL_AO_BURST_CLK_SRC
	errs	+= ao_burst_enable_test(args->fd);	// AIO_IOCTL_AO_BURST_ENABLE
	errs	+= ao_clk_src_test(args->fd);		// AIO_IOCTL_AO_CLK_SRC
	errs	+= ao_looping_test(args->fd);		// AIO_IOCTL_AO_LOOPING
	errs	+= ao_sync_test(args->fd);			// AIO_IOCTL_AO_SYNC
	errs	+= ao_timing_test(args->fd);		// AIO_IOCTL_AO_TIMING

	errs	+= aux_read_test(args->fd);			// AIO_IOCTL_AUX_READ
	errs	+= aux_write_test(args->fd);		// AIO_IOCTL_AUX_WRITE

	errs	+= dio_dir_out_test(args->fd);		// AIO_IOCTL_DIO_DIR_OUT
	errs	+= dio_read_test(args->fd);			// AIO_IOCTL_DIO_READ
	errs	+= dio_write_test(args->fd);		// AIO_IOCTL_DIO_WRITE

	errs	+= irq0_sel_test(args->fd);			// AIO_IOCTL_IRQ0_SEL
	errs	+= irq1_sel_test(args->fd);			// AIO_IOCTL_IRQ1_SEL
	errs	+= irq2_sel_test(args->fd);			// AIO_IOCTL_IRQ2_SEL

	errs	+= data_format_test(args->fd);		// AIO_IOCTL_DATA_FORMAT
	errs	+= ext_sync_src_test(args->fd);		// AIO_IOCTL_EXT_SYNC_SRC

	errs	+= range_test(args->fd);			// AIO_IOCTL_RANGE
	errs	+= rga_enable_test(args->fd);		// AIO_IOCTL_RGA_ENABLE
	errs	+= rga_nrate_test(args->fd);		// AIO_IOCTL_RGA_NRATE
	errs	+= rgb_clk_src_test(args->fd);		// AIO_IOCTL_RGB_CLK_SRC
	errs	+= rgb_enable_test(args->fd);		// AIO_IOCTL_RGB_ENABLE
	errs	+= rgb_nrate_test(args->fd);		// AIO_IOCTL_RGB_NRATE

	errs	+= rx_io_abort_test(args->fd);		// AIO_IOCTL_RX_IO_ABORT
	errs	+= rx_io_mode_test(args->fd);		// AIO_IOCTL_RX_IO_MODE
	errs	+= rx_io_timeout_test(args->fd);	// AIO_IOCTL_RX_IO_TIMEOUT

	errs	+= tx_io_abort_test(args->fd);		// AIO_IOCTL_TX_IO_ABORT
	errs	+= tx_io_mode_test(args->fd);		// AIO_IOCTL_TX_IO_MODE
	errs	+= tx_io_timeout_test(args->fd);	// AIO_IOCTL_TX_IO_TIMEOUT

	errs	+= wait_event_test(args->fd);		// AIO_IOCTL_WAIT_EVENT
	errs	+= wait_cancel_test(args->fd);		// AIO_IOCTL_WAIT_CANCEL
	errs	+= wait_status_test(args->fd);		// AIO_IOCTL_WAIT_STATUS

	return(errs);
}


