// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/utils/util_ai_scan_size.c $
// $Rev: 44027 $
// $Date: 2018-11-06 15:20:54 -0600 (Tue, 06 Nov 2018) $

// 16AIO: Utilities Library: source file

#include "main.h"



/******************************************************************************
*
*	Function:	aio_ai_scan_size
*
*	Purpose:
*
*		Provide a visual wrapper for the AIO_IOCTL_AI_SCAN_SIZE service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int aio_ai_scan_size(int fd, int index, int verbose, s32 set, s32* get)
{
	char		buf[128];
	int			errs;
	const char*	ptr;
	int			ret;

	if (verbose)
		gsc_label_index("AI Scan Size", index);

	ret		= aio_ioctl(fd, AIO_IOCTL_AI_SCAN_SIZE, &set);
	errs	= ret ? 1 : 0;


	switch (set)
	{
		default:

			errs++;
			ptr	= buf;
			sprintf(buf, "Unrecognized option: 0x%lX", (long) set);
			break;

		case AIO_AI_SCAN_SIZE_SINGLE:

			ptr	= "A Single Channel";
			break;

		case AIO_AI_SCAN_SIZE_0_1:

			ptr	= "Chanels 0 to 1";
			break;

		case AIO_AI_SCAN_SIZE_0_3:

			ptr	= "Channels 0 to 3";
			break;

		case AIO_AI_SCAN_SIZE_0_7:

			ptr	= "Channels 0 to 7";
			break;

		case AIO_AI_SCAN_SIZE_0_15:

			ptr	= "Channels 0 to 15";
			break;

		case AIO_AI_SCAN_SIZE_0_31:

			ptr	= "Channels 0 to 31";
			break;
	}

	if (verbose)
		printf("%s  (%s)\n", errs ? "FAIL <---" : "PASS", ptr);

	if (get)
		get[0]	= set;

	return(errs);
}


