// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/16AIO/16AIO_Linux_4.x.x.x_DN/utils/util_ao_buf_clear.c $
// $Rev: 44027 $
// $Date: 2018-11-06 15:20:54 -0600 (Tue, 06 Nov 2018) $

// 16AIO: Utilities Library: source file

#include "main.h"



/******************************************************************************
*
*	Function:	aio_ao_buf_clear
*
*	Purpose:
*
*		Provide a visual wrapper for the AIO_IOCTL_AO_BUF_CLEAR service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int aio_ao_buf_clear(int fd, int index, int verbose)
{
	int	errs;
	int	ret;
	s32	set;

	if (verbose)
		gsc_label_index("AO Buffer Clear", index);

	ret		= aio_ioctl(fd, AIO_IOCTL_AO_BUF_CLEAR, &set);
	errs	= ret ? 1 : 0;


	if (verbose)
		printf("%s\n", errs ? "FAIL <---" : "PASS");

	return(errs);
}


